// wN88-Disk BASIC(2D)xt@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include "d88.h"

static unsigned char dir[0x100 * 12];		// Directory (12sector)
static unsigned char fat[0x100];			// FAT (1sector)
static unsigned char buffer[0x100*16*0x50];	// 256byte x 16sector x 80track
static char dirpath[FILENAME_MAX];			// 쐬fBNg

int main(int argc, char *argv[])
{
	int mode=1;

	fprintf(stderr,"N88-Disk BASIC [2D] FILE CUTTER version 0.1\n");
	if (argc==3 && !strcmp(argv[2],"-d"))
	{
		mode=0;
	}
	else if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] [-d]\n",argv[0]);
		fprintf(stderr, "       -d : not make sub directory\n");
		return 1;
	}

	D88 disk;
	FILE *fp;

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W
	int d;

	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);					// P
		disk.SetRecordRange(0x01,0x10);		// PgbN16ZN^(N=1)

		sprintf(dirpath,"%03d",d);	// fBNg̐
		if (mode)
		{
			_mkdir(dirpath);				// fBNg쐬
			_chdir(dirpath);				//
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}
		else printf("\n[%s]\n",disk.GetDiskName());

		disk.ReadDATA(0x12*2+1, 0x12, 0x01, 0x01, 0x01, dir, sizeof(dir));	// fBNgŜǂݍ
		disk.ReadDATA(0x12*2+1, 0x12, 0x01, 0x0e, 0x01, fat, sizeof(fat));	// FATŜǂݍ

		// fBXNC[WۂƓǂݍ
		for (int trk = 0; trk < 80; trk++) {
			disk.ReadDATA(trk, trk/2, trk&1, 0x01, 0x01, &buffer[0x100*16*trk], 0x100*16);
		}

		// t@C̐؂o
		for (int fn = 0; fn < sizeof(dir)/16; fn++) {
			unsigned char *ent = &dir[fn * 16];		// fBNgGg|C^`

			if (ent[0] == 0x00) continue;	// killꂽt@C̓XLbv
			if (ent[0] == 0xff) break;		// fBNg̍Ō

			char fname[FILENAME_MAX];		// t@C

			int i;
			int fnp = 0;
			for (i = 0; i < 6; i++) {
				char c = ent[i];		// t@CPo
				if (c==' ') break;		// 
				fname[fnp++] = c;		// t@C\
			}
			if (ent[6] != ' ') {		// gqKvȂt
				fname[fnp++] = '.';
				for (i = 6; i < 9; i++) {	// 悤Ɋgqo
					char c = ent[i];
					if (c == 0x20) break;
					fname[fnp++] = c;
				}
			}
			fname[fnp++] = '\0';		// ̍Ō

			fp = fopen(fname, "wb");	// o̓t@CI[v
			printf("%-9s\n",fname);		// t@C\

			int cruster = ent[10];		// JnNX^

			while (fat[cruster] < 0xc0) {
				fwrite(&buffer[cruster*0x100*8], 1, 0x100*8, fp);	// 1NX^
				if (ferror(fp)) {
					fprintf(stderr, "t@C߂܂\n");
					return 1;
				}
				cruster = fat[cruster];	// FAT`FCH
			}

			fwrite(&buffer[cruster*0x100*8], 1, 0x100*(fat[cruster] & 0x0f), fp);	// `FC̍Ō
			if (ferror(fp)) { 
				fprintf(stderr, "t@C߂܂\n");
				return 1;
			}

			fclose(fp);		// t@CN[Y
			if (ferror(fp)) { 
				fprintf(stderr, "t@C߂܂\n");
				return 1;
			}
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}
